from urllib.parse import urlparse, parse_qsl
from http.server import HTTPServer, BaseHTTPRequestHandler

# https://stackoverflow.com/a/19211760

KEEP_RUNNING = True

def keep_running():
    return KEEP_RUNNING

def stop_running():
    KEEP_RUNNING = False

class MyHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        url = urlparse(self.path)
        q = parse_qsl(url.query)

        with open('/tmp/query','a') as f:
            f.write('%s\n'%(q))

        #send code 200 response
        self.send_response(200)

        #send header first
        self.send_header('Content-type','text-html')
        self.end_headers()

        #send file content to client
        self.wfile.write(str.encode("<html><body><h1>hi!</h1></body></html>"))
        f.close()

        stop_running()

        return


def run(server_class=HTTPServer, handler_class=BaseHTTPRequestHandler):
    server_address = ('', 8000)
    httpd = server_class(server_address, handler_class)

    httpd.handle_request()

    #### forever
    ####httpd.serve_forever()

    ####while keep_running():
    ###    # one and done
    ###    # httpd.handle_request()


if __name__=="__main__":
    run(handler_class=MyHandler)
